/* 
 * Init wrapper for security daemon for Medusa DS9 security system
 */

/*
 * These variables determine paths to constable and original init and
 * parameters for constable. Customize them for your system.
 */

#define MEDUSA_DAEMON "/usr/local/sbin/constable"
#define MEDUSA_DAEMON_NAME "constable"
#define MEDUSA_DEVICE "/dev/medusa"
#define MEDUSA_CONFFILE "/usr/local/etc/constable.conf"
#define ORIGINAL_INIT "/sbin/init.orig"


#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>


int main(int argc, char *argv[])
{
	int i, status;

	switch ((i = fork())) {
	case -1:
		exit(-1);
	case 0:
		execl(MEDUSA_DAEMON, MEDUSA_DAEMON_NAME, MEDUSA_DEVICE,
		      MEDUSA_CONFFILE, NULL);
		exit(-1);
	default:
		waitpid(i, &status, 0);
		if (!WIFEXITED(status))
			exit(-1);
		argv[0] = "init";
		execv(ORIGINAL_INIT, argv);
	}
	return -1;
}
